BEGIN{
    hex[0] = 0;     hex[1] = 1;     hex[2] = 2;     hex[3] = 3;
    hex[4] = 4;     hex[5] = 5;     hex[6] = 6;     hex[7] = 7;
    hex[8] = 8;     hex[9] = 9;     hex["A"] = 10;  hex["B"] = 11;
    hex["C"] = 12;  hex["D"] = 13;  hex["E"] = 14;  hex["F"] = 15;
}
! /^[ 0-9a-f][ 0-9a-f]*:/{
	print $0
}
/^[ 0-9a-f][ 0-9a-f]*:/{
	addr = hex2dec_addr($0);
	sub(/^[ 0-9a-f][ 0-9a-f]*:/ , "", $0);
	if (match($0, /[0-9a-f][0-9a-f] [0-9a-f][0-9a-f] [0-9a-f][0-9a-f] [0-9a-f][0-9a-f] /)) {
		s = substr($0, RSTART, RLENGTH);
		v1 = substr(s, 1, 2);
                v2 = substr(s, 4, 2);
                v3 = substr(s, 7, 2);
                v4 = substr(s, 10, 2);
		s2 = " " v2 v1 "  " v4 v3 " ";

		prev = $0;
		sub(/[0-9a-f][0-9a-f] [0-9a-f][0-9a-f] [0-9a-f][0-9a-f] [0-9a-f][0-9a-f] /, s2, prev);
		if (match(v2, /9[13]/)) {
			printf("#%3x:%s\n", addr/2, prev);
			reg =  hex2dec(v1,1);
			reg -= reg % 16;
#printf("### inst = %04x  l/s = %04x\n",inst,(substr(v2, 2, 1) - 1) * 1024);
			inst = 32768 + 8192 + (substr(v2, 2, 1) - 1) * 1024;
#printf("### inst = %04x  reg = %04x\n",inst,reg);
			inst += reg;
			ea = hex2dec(v4,1) * 256 + hex2dec(v3,1);
#printf("### inst = %04x  ea = %04x\n",inst,ea);
			inst += ea % 16;
			ea -= ea % 16;
#printf("### inst = %04x  ea = %04x (%04x)\n",inst,ea, (ea * 32) % 2048);
			inst += (ea * 32) % 2048;
			ea = (ea * 32) - (ea * 32) % 2048;
#printf("### inst = %04x  ea = %04x\n",inst,ea);
			if (ea != 2048) {
				inst += 256;
			}
#printf("### inst = %04x  ea = %04x\n",inst,ea);
			s2 = sprintf(" %04x  0000 ",inst);
			sub(/[0-9a-f][0-9a-f] [0-9a-f][0-9a-f] [0-9a-f][0-9a-f] [0-9a-f][0-9a-f] /, s2, $0);
			printf("%4x:%s\n", addr/2, $0);
		} else {
			printf("%4x:%s\n", addr/2, prev);
		}
	} else if (match($0, /[0-9a-f][0-9a-f] [0-9a-f][0-9a-f] /)) {
		s = substr($0, RSTART, RLENGTH);
		v1 = substr(s, 1, 2);
                v2 = substr(s, 4, 2);
		s2 = " " v2 v1 " ";
		
		sub(/[0-9a-f][0-9a-f] [0-9a-f][0-9a-f] /, s2, $0);
		printf("%4x:%s\n", addr/2, $0);
	} else {
		printf("%4x:%s\n", addr/2, $0);
	}
}

function hex2dec_addr(str, x) {
    x = 0;
    m = index(str,":");
    if (m == 0) return x;
    for (i=1; i<m; i++) {
	c = hex[toupper(substr(str,i,1))];
	x = x * 16 + c;
    }
    return x;
}

function hex2dec(str, i, x) {
    x = hex[toupper(substr(str,i,1))] * 16 + hex[toupper(substr(str,i+1,1))];
    return x;
}
