#ifndef target_h
#define target_h

#ifdef __cplusplus
extern "C" {
#endif

typedef struct target *TARGET;

struct target {
	int  (* sel_chan)(TARGET tgt, CABLE cbl, int chan);
	int  (* read_conf)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* write_conf)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* read_flash)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* write_flash)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* erase_flash)(TARGET tgt, CABLE cbl);

	uint32_t device_id;
	uint32_t user_id;
	uint32_t crc_data; // optinal 

	/* for lattice FPGA's parameter */
	int address_size;
	int data_width;
	int boundary_width;
	char *device_name;
};

#ifdef __cplusplus
}
#endif

#endif /* target_h */
